unit UMain;

interface

uses
  Windows, Messages, SysUtils, Variants, Classes, Graphics, Controls, Forms,
  Dialogs, iniFiles, DB, ADODB, StdCtrls, ComCtrls, Buttons;

type
  TForm1 = class(TForm)
    ADOConnection1: TADOConnection;
    Label1: TLabel;
    Label2: TLabel;
    Label3: TLabel;
    Label4: TLabel;
    edtServer: TEdit;
    edtUSer: TEdit;
    edtPassword: TEdit;
    lblConnect: TLabel;
    Button1: TButton;
    lblErr: TLabel;
    StatusBar1: TStatusBar;
    cbBD: TComboBox;
    SpeedButton1: TSpeedButton;
    ADOQuery1: TADOQuery;
    ADOConnection2: TADOConnection;
    procedure FormShow(Sender: TObject);
    procedure Button1Click(Sender: TObject);
    procedure SpeedButton1Click(Sender: TObject);
  private
    ini:TIniFile;
  public
    { Public declarations }
  end;

var
  Form1: TForm1;

const
  STR_CONN = 'Provider=SQLOLEDB.1;Password=%s;Persist Security Info=True;' +
             'User ID=%s;Initial Catalog=%s;Data Source=%s';
  CONFIG_SECTION = 'ConfigDB';
  STR_EMPTY = '';

implementation

{$R *.dfm}

procedure TForm1.FormShow(Sender: TObject);
var
  user, psw, server, DataBase:string;
  fName:string;
  TS:TStrings;
begin
  // Fichero ini
  fName := ChangeFileExt(Application.ExeName,'.ini');
  // Ni existe?
  if not FileExists(fName) then begin
    MessageDlg('No se ha encontrado el fichero de configuracin (primera vez que se ejecuta el programa); Rellene los valores y grabe.', mtInformation, [mbOK], 0);
    exit;
  end;

  // Cargar el fichero INI
  ini := TIniFile.Create(fName);
  // proteccion para liberar
  try
    // Cargar datos
    edtUSer.Text := ini.ReadString(CONFIG_SECTION, 'User', STR_EMPTY);
    edtPassword.Text := ini.ReadString(CONFIG_SECTION, 'password', STR_EMPTY);
    edtServer.Text := ini.ReadString(CONFIG_SECTION, 'Server', STR_EMPTY);
    cbBD.Text := ini.ReadString(CONFIG_SECTION, 'BaseDatos', STR_EMPTY);


//    TS := TStringList.Create();
//    TS.LoadFromFile('r:\conn.txt');
//    ADOConnection1.ConnectionString := TS.Text;
//    TS.Free;
//
//    ADOConnection1.OPen;


    // Intentar conectar
    ADOConnection1.ConnectionObject.ConnectionString :=
      Format(STR_CONN, [edtPassword.Text, edtUser.Text, cbBD.Text, edtServer.Text]);
    try
      ADOConnection1.Open;
      lblConnect.Caption := 'Conexin correcta.';
      lblConnect.Font.Color := clGreen;
      lblErr.Visible := False;
    except
      on E:Exception do begin
        // Error
        lblConnect.Caption := 'No se ha podido conectar.';
        lblConnect.Font.Color := clMaroon;
        lblErr.Visible := True;
        lblErr.Caption := E.Message;
      end;
    end;
  finally
    FreeAndNil(ini);
  end;
end;

procedure TForm1.Button1Click(Sender: TObject);
var
  fName:string;
  TS:TStrings;
begin
  // Fichero ini
  fName := ChangeFileExt(Application.ExeName,'.ini');
  // Grabar en el fichero INI
  ini := TIniFile.Create(fName);
  // proteccion para liberar
  try
    // Grabar
    ini.WriteString(CONFIG_SECTION, 'User', edtUser.Text);
    ini.WriteString(CONFIG_SECTION, 'password', edtPassword.Text);
    ini.WriteString(CONFIG_SECTION, 'Server', edtServer.Text);
    ini.WriteString(CONFIG_SECTION, 'BaseDatos', cbBD.Text);

  finally
    FreeAndNil(ini);
  end;

//  TS := TStringList.Create();
//  TS.Text := ADOConnection1.ConnectionString;
//  TS.SaveToFile('r:\conn.txt');
//  TS.Free;

  MessageDlg('Reinicie la aplicacin para conectar con los nuevos valores.', mtInformation, [mbOK], 0);
  Self.Close;

end;

procedure TForm1.SpeedButton1Click(Sender: TObject);
var
  Str:string;
begin

  // Intentar conectar
  ADOConnection2.ConnectionObject.ConnectionString :=
    Format(STR_CONN, [edtPassword.Text, edtUser.Text, 'master', edtServer.Text]);

  try
    ADOConnection2.Open;
    ADOQuery1.SQL.Text := 'Select * from SysDataBases';
    ADOQuery1.Open;

    while not (ADOQuery1.Eof) do begin
      Str := ADOQuery1.FieldByName('name').AsString;
      cbBD.Items.Add(Str);
      ADOQuery1.Next;
    end;

    cbBD.ItemIndex := 0;

  except
    on E:Exception do begin
      MessageDlg('Error: ' + E.Message, mtWarning, [mbOK], 0);
    end;
  end;



end;

end.
